-------------------------------------------------------------------------------
-- FUNCTION
-------------------------------------------------------------------------------
local lastTarg
local HighlightStuff
function TargetChange()
	local targ = avatar.GetSecondaryTarget()
	local color = {r = 0.00; g = 0.88; b = 0.78; a = 1}
	if targ and unit.IsAggressive(targ) == false then
		color = {r=.7;g=.5;b=0;a=1}
		if unit.IsFriend(targ) then
			color = {r=0;g=1;b=0;a=1}
		end
	end
	if lastTarg and object.IsExist(lastTarg) then
		object.Highlight(lastTarg, "SELECTION", nil, nil, 0)
	end
	if targ then 
		object.Highlight(targ, "SELECTION", color, nil, 0)
		object.SetCutTerrainArea(targ, 1.0, 1.5)
	end
	lastTarg = targ
end

function Slash(p)
	if string.find(userMods.FromWString(p.text), "/tar") then
		if string.sub(userMods.FromWString(p.text), 5) ~= "" then
			for i, v in avatar.GetUnitList() do
				if object.IsExist(v) then 
					if string.find(userMods.FromWString(object.GetName(v)), string.sub(userMods.FromWString(p.text), 6)) then 
						if avatar.GetTarget() ~= v then
							avatar.SelectTarget(v) break
						end
					end
				end
			end
		else avatar.TargetSelf() 
		end
	end
end

local function HighlightIt(id)
	if id ~= avatar.GetSecondaryTarget() then
		local color = {r=1;g=0;b=0;a=.3}
		local color2 = {r=.7;g=0;b=0;a=.3}
		if object.IsUnit(id) then
			if unit.IsAggressive(id) == false then
				color = {r=.7;g=.5;b=0;a=.3}
				color2 = {r=.4;g=.2;b=0;a=.3}
				if unit.IsFriend(id) then
					color = {r=0;g=1;b=0;a=.3}
					color2 = {r=0;g=.4;b=0;a=.3}
				end
			end
		elseif object.IsDevice(id) then
			color = {r=.5;g=0;b=0;a=.3}
			color2 = {r=.2;g=0;b=0;a=.3}
			if object.IsUsable(id) then
				color = {r=0;g=0;b=.7;a=.3}
				color2 = {r=0;g=0;b=.4;a=.3}
			end
		end
		object.Highlight(id, "SELECTION", color, nil, 0)
		object.Highlight(id, "AMBIENT", color, color2, 1.3)
	end
end

function UnitSpawned(p)
	if HighlightStuff then
		HighlightIt(p.unitId)
	end
end
function DevSpawned(p)
	if HighlightStuff then
		HighlightIt(p.id)
	end
end

local function UnHighlightIt(id)
	if id ~= avatar.GetSecondaryTarget() then
		object.Highlight(id, "SELECTION", nil, nil, 0)
		object.Highlight(id, "AMBIENT", nil, nil, 0)
	end
end

function TargHighlight(r)
	if r.active then
		HighlightStuff = not HighlightStuff
		
		if HighlightStuff then
			for i, v in avatar.GetDeviceList() do
				HighlightIt(v)
			end
			for i, v in avatar.GetUnitList() do
				HighlightIt(v)
			end
		else
			for i, v in avatar.GetDeviceList() do
				UnHighlightIt(v)
			end
			for i, v in avatar.GetUnitList() do
				UnHighlightIt(v)
			end
		end
	end
end
--------------------------------------------------------------------------------
-- INITIALIZATION
--------------------------------------------------------------------------------
function Init()
	common.StateUnloadManagedAddon( "TargetSelection" )
	common.RegisterEventHandler(TargetChange, "EVENT_AVATAR_SECONDARY_TARGET_CHANGED")
	common.RegisterEventHandler(Slash, "EVENT_UNKNOWN_SLASH_COMMAND")
	common.RegisterEventHandler(UnitSpawned, "EVENT_UNIT_SPAWNED")
	common.RegisterEventHandler(DevSpawned, "EVENT_DEVICE_SPAWNED")
	common.RegisterEventHandler(TargetChange, "EVENT_UNIT_RELATION_CHANGED")
	common.RegisterEventHandler(TargetChange, "EVENT_UNIT_PVP_FLAG_CHANGED")
	common.RegisterEventHandler(TargetChange, "EVENT_UNIT_NAME_CHANGED")
	common.RegisterEventHandler(TargetChange, "EVENT_UNIT_TAG_CHANGED")
	common.RegisterReactionHandler(TargHighlight, "highlight_objects")
end
--------------------------------------------------------------------------------
common.RegisterEventHandler( Init, "EVENT_AVATAR_CREATED")
if avatar.IsExist() then
Init()
end
--------------------------------------------------------------------------------